Codeforces 600B Queries about less or equal elements(二分查找)

B. Queries about less or equal elements
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given two arrays of integers a and b. For each element of the second array bj you should find the number of elements in array athat are less than or equal to the value bj.

Input

The first line contains two integers n, m (1 ≤ n, m ≤ 2·105) — the sizes of arrays a and b.

The second line contains n integers — the elements of array a ( - 109 ≤ ai ≤ 109).

The third line contains m integers — the elements of array b ( - 109 ≤ bj ≤ 109).

Output

Print m integers, separated by spaces: the j-th of which is equal to the number of such elements in array a that are less than or equal to the value bj.

Sample test(s)
input
5 4
1 3 5 7 9
6 4 2 8
output
3 2 1 4
input
5 5
1 2 1 2 5
3 1 4 1 5
output
4 2 4 2 5


题意:求b数组中每个元素在a数组中比其小或者等于的数的个数。


sort排序之后,暴力一发超时,我真是菜啊,居然第一反应是暴力。

很简单的二分查找,C++STL里面的upper_bound(a,a+n,k)函数求出的值就表示的是指向满足ai>k的ai的最小指针。

所以用STL求解很简单,代码如下:


#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int a[200010],b[200010];
int main()
{
	int n,m,i,j;
	while(scanf("%d%d",&n,&m)!=EOF)
	{
		for(i=0;i<n;++i)
			scanf("%d",&a[i]);
		sort(a,a+n);
		for(j=0;j<m;++j)
			scanf("%d",&b[j]);
		for(i=0;i<m;++i)
		{
			if(i==m-1)
				printf("%d\n",upper_bound(a,a+n,b[i])-a);
			else 
				printf("%d ",upper_bound(a,a+n,b[i])-a);
		} 
	}
	return 0;
} 



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值